## START: Set by rpmautospec
## (rpmautospec version 0.6.1)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 26;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

%global forgeurl https://github.com/BenHanson/lexertl14
%global commit 30972462cb07ac98dca4987d4d011e38ee86ea40

Name:           lexertl14
Summary:        The Modular Lexical Analyser Generator
Version:        0.1.0
%forgemeta
Release:        %autorelease

URL:            %{forgeurl}
License:        BSL-1.0
Source0:        %{forgesource}

BuildRequires:  gcc-c++
BuildRequires:  cmake
BuildRequires:  dos2unix

# No compiled binaries are installed, so this would be empty.
%global debug_package %{nil}

%global common_description %{expand:
This is the C++14 version of lexertl. Please prefer lexertl17 wherever
possible.}

%description %{common_description}


%package devel
Summary:        %{summary}

# Header-only library:
Provides:       lexertl14-static = %{version}-%{release}

Provides:       lexertl14-examples = %{version}%{release}
Obsoletes:      lexertl14-examples < 0.1.0-26.20240301git3097246

%description devel %{common_description}


%prep
%forgeautosetup -p1

# Fix line terminations (particularly for files that may be installed)
find . -type f -exec file '{}' '+' |
  grep -E '\bCRLF\b' |
  cut -d ':' -f 1 |
  xargs -r dos2unix --keepdate


%build
%cmake -DBUILD_TESTING:BOOL=ON -DBUILD_EXAMPLES:BOOL=ON
%cmake_build

# Make a copy of the examples directory without CMakeLists.txt files, which are
# not useful without the top-level CMakeLists.txt for the project.
mkdir _cleaned
cp -rvp examples _cleaned
find _cleaned/examples -type f -name CMakeLists.txt -print -delete


%install
%cmake_install


%check
%ctest


%files devel
%license include/lexertl/licence_1_0.txt
%doc README.md
%doc _cleaned/examples/

%{_includedir}/lexertl/

%{_libdir}/cmake/lexertl/


%changelog
## START: Generated by rpmautospec
* Fri Mar 01 2024 Benjamin A. Beasley <code@musicinmybrain.net> - 0.1.0-26
- Fix Obsoletes for lexertl14-examples

* Fri Mar 01 2024 Benjamin A. Beasley <code@musicinmybrain.net> - 0.1.0-25
- Update to 0.1.0^20240301git3097246, with upstream fix for examples

* Fri Mar 01 2024 Benjamin A. Beasley <code@musicinmybrain.net> - 0.1.0-24
- Move the examples into the -devel subpackage

* Fri Mar 01 2024 Benjamin A. Beasley <code@musicinmybrain.net> - 0.1.0-23
- Do not install useless CMakeLists.txt files with examples

* Fri Mar 01 2024 Benjamin A. Beasley <code@musicinmybrain.net> - 0.1.0-22
- Ensure the examples actually compile

* Fri Feb 16 2024 Benjamin A. Beasley <code@musicinmybrain.net> - 0.1.0-21
- Update to 0.1.0^20240216git7a365a2

* Fri Feb 16 2024 Benjamin A. Beasley <code@musicinmybrain.net> - 0.1.0-20
- Keep timestamps when converting text file line endings

* Fri Feb 16 2024 Benjamin A. Beasley <code@musicinmybrain.net> - 0.1.0-19
- Update to c045058 (multilib fixed upstream)

* Sat Sep 09 2023 Benjamin A. Beasley <code@musicinmybrain.net> - 0.1.0-18
- Use a proper patch to fix multilib paths, and offer it upstream

* Sat Sep 09 2023 Benjamin A. Beasley <code@musicinmybrain.net> - 0.1.0-16
- Improve the Summary

* Sat Sep 09 2023 Benjamin A. Beasley <code@musicinmybrain.net> - 0.1.0-15
- Update to 86c90c3 (Restore the ability to run tests with BUILD_TESTING
  and ctest)

* Sat Sep 09 2023 Benjamin A. Beasley <code@musicinmybrain.net> - 0.1.0-14
- Update to 5bd3180
- Changed from std::size_t to uint16_t for ease of use
- Added missing #include and functions
- regex macro BOL and EOL fixes
- Added exit state syntax check for missing right chevron

* Sat Sep 09 2023 Benjamin A. Beasley <code@musicinmybrain.net> - 0.1.0-13
- Update to c4bcaf8
- More SonarLint etc changes
- Applied SA changes
- Added tests

* Sat Sep 09 2023 Benjamin A. Beasley <code@musicinmybrain.net> - 0.1.0-12
- Update to 2e2893c
- Added replace.hpp
- Now throwing exception in case of stack underflow
- Updated serialization support
- More use of auto
- Use cend()
- More UTF-32 support
- Added stream_num.hpp
- Fixed #include

* Sat Sep 09 2023 Benjamin A. Beasley <code@musicinmybrain.net> - 0.1.0-11
- Update to aeddda8 (Unicode 15.1.0 and other minor enhancements)

* Sat Sep 09 2023 Benjamin A. Beasley <code@musicinmybrain.net> - 0.1.0-10
- Indicate dirs. in files list with trailing slashes

* Sat Sep 09 2023 Benjamin A. Beasley <code@musicinmybrain.net> - 0.1.0-9
- Update to 8b8ead2 (Update to the latest Unicode standard)

* Sat Sep 09 2023 Benjamin A. Beasley <code@musicinmybrain.net> - 0.1.0-8
- Update License to SPDX

* Sat Sep 09 2023 Benjamin A. Beasley <code@musicinmybrain.net> - 0.1.0-7
- Update to cd5a1f1 (Unicode 15)

* Wed Dec 22 2021 Benjamin A. Beasley <code@musicinmybrain.net> - 0.1.0-6
- Update to 2ea71b8

* Wed Dec 22 2021 Benjamin A. Beasley <code@musicinmybrain.net> - 0.1.0-5
- Dep. on cmake-filesystem is now auto-generated

* Wed Dec 22 2021 Benjamin A. Beasley <code@musicinmybrain.net> - 0.1.0-4
- Update to commit 488602f

* Wed Aug 25 2021 Benjamin A. Beasley <code@musicinmybrain.net> - 0.1.0-1
- Initial package for EPEL8

## END: Generated by rpmautospec
